#include <map>
#include <string>
#include <hdf5.h>


#ifndef _H_H5DTYPE
#define _H_H5DTYPE


/**
 * addind new datatype:
 * To add a basic datatype
 *       1) Open h5datatype.cc
 *       2) add a line like dtype_["..."] = ... in Dtype::Dtype correspondint to it
 *
 * To add a compound datatype
 *       1) Open h5datatype.cc
 *       2) define it on top of Dtype::Dtype
 *       3) add a line like dtype_["..."] = ... correspondint to it
 *
 */
namespace h5 {
	class Dtype {

		static std::map<std::string, hid_t> dtype_;

		static hid_t compound_type_native_complex_float_;
		static hid_t compound_type_native_complex_double_;

		static unsigned int reference_count_;    /**<  Keeps a count of number of instances of this class.
		                                               Last instance closes compound types. */

		std::string selected_dtype_str_;


	public:
		Dtype(std::string dtype_str);

		static void init();
		static void finalize();

		operator hid_t() const { return this->dtype_[this->selected_dtype_str_]; }
	};
}

#endif
