#ifndef _H_H5EXPRESSION
#define _H_H5EXPRESSION


#include <vector>
#include "h5select.h"

namespace h5 {

class Expression {
	public:
	std::vector<Select> expression;

	typedef std::vector<Select>::size_type size_type;

	Expression() {};
	Expression(Select select) {this->expression.push_back(select);}
	Expression(std::string expression_str);
	
	void Add_select(const Select &select);
	void Subtract_select(const Select &select);

	void Insert(const Select &select, size_t index=-1);
	void Remove(size_t index);

	size_t size() const { return expression.size(); }

	bool isEmpty() const{ return (expression.size()==0); }

	void Pretty_print(std::string &str, bool print_first_positive=false) const;

	Expression& operator=(const Select &select);

    Select& operator [](int i) { return expression[i]; }
};

}

std::ostream& operator<< (std::ostream& stream, const h5::Expression& expression);
#endif