#include "h5node.h"
#include "h5group.h"

namespace h5 {

	Node::Node(Group *parent, std::string name) {
		this->parent_ = parent;
		this->name_ = name;

		H5Oget_info_by_name(parent->id(), name.c_str(), &this->info_, H5P_DEFAULT);
	}

	void Node::close_all() {
		/*if (this->isGroup())
			Group(*this).close_all();

		else if (this->isDataset())
			Dataset(*this).close();*/
	}

	H5O_type_t Node::is() {
		return this->info_.type;
	}

	bool Node::isUnknown() {
		return (this->info_.type == H5O_TYPE_UNKNOWN);
	}

	bool Node::isGroup() {
		return (this->info_.type == H5O_TYPE_GROUP);
	}

	bool Node::isDataset() {
		return (this->info_.type == H5O_TYPE_DATASET);
	}

	bool Node::isNamedDatatype() {
		return (this->info_.type == H5O_TYPE_NAMED_DATATYPE);
	}

	bool Node::isNtypes() {
		return (this->info_.type == H5O_TYPE_NTYPES);
	}

	Node::operator Group() {
		return Group(this->parent_, this->name_, "r");
	}

	Node::operator Dataset() {
		return Dataset(this->parent_, this->name_);
	}
}
//========================= Class declaration of H5File ends ============================== 

