#include "h5shape.h"

namespace h5 {
	std::vector<hsize_t> shape(hsize_t d0) {
		std::vector<hsize_t> vec(1);
		vec[0] = d0;
		return vec;
	}

	std::vector<hsize_t> shape(hsize_t d0, hsize_t d1) {
		std::vector<hsize_t> vec(2);
		vec[0] = d0;
		vec[1] = d1;
		return vec;
	}

	std::vector<hsize_t> shape(hsize_t d0, hsize_t d1, hsize_t d2) {
		std::vector<hsize_t> vec(3);
		vec[0] = d0;
		vec[1] = d1;
		vec[2] = d2;
		return vec;
	}

	std::vector<hsize_t> shape(hsize_t d0, hsize_t d1, hsize_t d2, hsize_t d3) {
		std::vector<hsize_t> vec(4);
		vec[0] = d0;
		vec[1] = d1;
		vec[2] = d2;
		vec[3] = d3;
		return vec;
	}

	std::vector<hsize_t> shape(hsize_t d0, hsize_t d1, hsize_t d2, hsize_t d3, hsize_t d4) {
		std::vector<hsize_t> vec(5);
		vec[0] = d0;
		vec[1] = d1;
		vec[2] = d2;
		vec[3] = d3;
		vec[4] = d4;
		return vec;
	}
}
